Package org.eclipse.m2m.atl.emftvm.impl

# Class RuleImpl.AutomaticSingleState

java.lang.Object
org.eclipse.m2m.atl.emftvm.impl.RuleImpl.RuleModeState
org.eclipse.m2m.atl.emftvm.impl.RuleImpl.AutomaticSingleState

Enclosing class:
  RuleImpl

protected class RuleImpl.AutomaticSingleState extends RuleImpl.RuleModeState
`RuleImpl.RuleModeState` class for rules with mode `RuleMode.AUTOMATIC_SINGLE`.

## Constructor Summary

Constructors
Modifier
Constructor
Description
`protected`
`AutomaticSingleState()`

## Method Summary

Modifier and Type
Method
Description
`boolean`
`matchFor(StackFrame frame, Object[] values)`
Matches this rule against `values`, and records a match in `ExecEnv.getMatches()` in case of a match.
`boolean`
`matchFor(StackFrame frame, Map<String,Object> valuesMap, Object[] values)`
Matches this rule against `values`, and records a match in `ExecEnv.getMatches()` in case of a match.
`boolean`
`matchSingle(StackFrame frame)`
Matches `#getRule()` for the automatic single stage, if applicable.

### Methods inherited from class org.eclipse.m2m.atl.emftvm.impl.RuleImpl.RuleModeState

`matchManual, matchRecursive`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### AutomaticSingleState

protected AutomaticSingleState()

## Method Details

### matchSingle

public boolean matchSingle(StackFrame frame)
Matches `#getRule()` for the automatic single stage, if applicable.

Overrides:
  `matchSingle` in class `RuleImpl.RuleModeState`
Parameters:
  `frame` - the stack frame in which to execute the matcher
Returns:
  `true` iff the rule has any matches

### matchFor

public boolean matchFor(StackFrame frame, Object[] values)
Matches this rule against `values`, and records a match in `ExecEnv.getMatches()` in case of a match. In case of a unique rule, this method will not match if the rule has already matched against `values` before.

Specified by:
  `matchFor` in class `RuleImpl.RuleModeState`
Parameters:
  `frame` - the stack frame context
  `values` - the source values to match against
Returns:
  `true` iff this rule matches against `values`

### matchFor

public boolean matchFor(StackFrame frame, Map<String,Object> valuesMap, Object[] values)
Matches this rule against `values`, and records a match in `ExecEnv.getMatches()` in case of a match. In case of a unique rule, this method will not match if the rule has already matched against `values` before.

Specified by:
  `matchFor` in class `RuleImpl.RuleModeState`
Parameters:
  `frame` - the stack frame context
  `valuesMap` - the map of all values, including super-rule elements
  `values` - the source values to match against
Returns:
  `true` iff this rule matches against `values`